////////////////////////////////////////////////////////////////
#define DT (0.01)
#define RD2DEG (57.3)
int ModelSamolotu(double A[][5],double B[][5]);
int StanSamolotu(double A[][5],double B[][5],double x[],double dt,double dH);


int Aircraft_Dynamics_alg(float Dhm,float *THM,float *qm)
{
	static double A[5][5];
	static double B[2][5];
	static int INIT=1;
	static double x[5]={0,0,0,0,0};
	
	if (INIT)
	{	int ret_val=0;
		INIT=0;
		ret_val=ModelSamolotu(A,B);
	}
	{
		int ret_val=0;
		ret_val=StanSamolotu(A,B,x,DT,Dhm); //Dhm w radianach!!!!
	}
	*qm=RD2DEG*x[2];   // qm: deg\sek
	*THM=RD2DEG*x[3];	// THM: deg
	
	// *THM=Dhm+0.5;
	// *qm=Dhm-0.5;
}

int ModelSamolotu(double A[][5],double B[][5])
{
double g=9.81;//%m/s^2
double H=4500;
double U0=142.7;
double m=86104;
double Xu=-0.00714;//%1/s
double Xw=-0.0321;//%1/s
double XdH=0;
double XdT=0;//%m/(s^2*rd)
double Zu=-0.1329;//%1/s
double Zw=-0.756;//%1/s
double ZdH=-7.22;//%m/^s^2*rd)
double Mu=-0.000207;//%1/sm
double Mwp=-0.0023622;//%1/m
double Mw=-0.035104;//%1/s
double Mq=-0.991;//%1/s
double MdH=-3.24;//%1/(s^2*rd)
double MdT=0.0;//%1/(s^2*rd)
double ZdT=0.0;//%m/(s^2*rd)
double k=1.0;
double  M1 = (Mu+Mwp*Zu)*k;
double  M2 = (Mw+Mwp*Zw)*k;
double  M3 = Mq+Mwp*U0;
double  M4 = MdH+Mwp*ZdH;
//double test;
int i;
int j;
A[0][0]=Xu;
A[0][1]=Xw;
A[0][2]=0.0;
A[0][3]=-g;
A[0][4]=0.0;

A[1][0]=Zu;
A[1][1]=Zw;
A[1][2]=U0;
A[1][3]=0.0;
A[1][4]=0.0;

A[2][0]=M1;
A[2][1]=M2;
A[2][2]=M3;
A[2][3]=0.0;
A[2][4]=0.0;

A[3][0]=0.0;
A[3][1]=0.0;
A[3][2]=1;
A[3][3]=0.0 ;
A[3][4]=0.0;

A[4][0]=0.0;
A[4][1]=-1;
A[4][2]=0.0;
A[4][3]=U0;
A[4][4]=0.0;

B[0][0]=XdH;
B[0][1]= -Xu;
B[0][2]=  -Xw;

B[1][0]=   ZdH;
B[1][1]= -Zu;
B[1][2]=  -Zw;

B[2][0]=   M4;
B[2][1]=  -M1;
B[2][2]=  -M2;
//test=A[0][0];
for(i=3;i<5;i++)
        for(j=0;j<3;j++)
                B[i][j]=0.0;
/*for(i=0;i<5;i++)
        for(j=0;j<5;j++)
                A[i][j]=A[i][j]*1000;
for(i=0;i<5;i++)
        for(j=0;j<3;j++)
                B[i][j]=B[i][j]*1000;
*/
return 0;
}
//**********************************************
//Funkcja wyliczajca atualny stan lotu samolotu
//**********************************************
//Parametry:
//A: macierz obiektu
//B: macierz wymusze
//x: wektor stanu samolotu
//dt: krok dyskretyzacji
//dH: wychylenie steru wysokosci
int StanSamolotu(double A[][5],double B[][5],double x[],double dt,double dH)
{
        static double q;
        static double xp[5];
        double A1[5][5];
        double B1[5][3];
        int i;
        int j;
        for(i=0;i<5;i++)
                for(j=0;j<5;j++)
                        A1[i][j]=A[i][j];
        for(i=0;i<5;i++)
                for(j=0;j<3;j++)
                        B1[i][j]=B[i][j];
        for(i=0;i<5;i++)
                xp[i]=0;
        for(i=0;i<5;i++)
        {
                //xp[i]=0;
                for(j=0;j<5;j++)
                {
                        xp[i]=xp[i]+A[i][j]*x[j];
                }
                //xp[i]=xp[i]+B[0][i]*dH;
                //Wyliczanie aktualnego stanu:
                //x[i]=x[i]+xp[i]*dt;
        }
        for(i=0;i<3;i++)
        {
                xp[i]=xp[i]+B[i][0]*dH;
                //Wyliczanie aktualnego stanu:
                //x[i]=x[i]+xp[i]*dt;
        }
        //q=x[2];
        xp[3]=x[2];
        xp[4]=x[1]*A[4][1]+x[3]*A[4][3];
        for(i=0;i<5;i++)
                x[i]=x[i]+xp[i]*dt;
        
        return 0;
}